function RecoverHealth(%player)
{
	if(!isObject(%player)) return;
	
	%damage = %player.getDamageLevel();
	%player.setDamageLevel(%damage - 1);
	%stamina = %player.getEnergyLevel();
	%amount = 20000/(%damage+10)+500-%stamina*5;

	if(%damage > 0) %player.recoverSched = schedule(%amount, 0, "RecoverHealth", %player);
}

function StaminaCheck(%player)
{
	if(!isObject(%player)) return;

	%player.checking = true;
	%stamina = %player.getEnergyLevel();
	if(%stamina <= 0 && %player.getState() !$= "Dead")
		%player.changeDatablock(PlayerDFArmor);
	%player.staminaSched = schedule(100, 0, "StaminaCheck", %player);
}
	

datablock PlayerData(PlayerDFArmor : PlayerStandardArmor)
{
	rechargeRate = 1;
	runEnergyDrain = 0.5;
	canJet = 0;
	uiName = "Dogfight Player";
	showEnergyBar = 1;
};

datablock PlayerData(PlayerDFSArmor : PlayerDFArmor)
{
	runEnergyDrain = 2;
	minRunEnergy = 1;
	jumpEnergyDrain = 25;

	maxForwardSpeed = 14;
	maxBackwardSpeed = 12;
	maxSideSpeed = 8;
	maxForwardCrouchSpeed = 6;
	maxBackwardCrouchSpeed = 4;
	maxSideCrouchSpeed = 4;
	maxUnderwaterForwardSpeed = 16.8;
	maxUnderwaterBackwardSpeed = 15.6;
	maxUnderwaterSideSpeed = 15.6;
	airControl = 0.2;
	uiName = "";
	canRide = 0;
	maxTimeScale = 3;
};

datablock PlayerData(PlayerSprintArmor : PlayerDFArmor)
{
	uiName = "Sprinting Player";
};

datablock PlayerData(PlayerSprintingArmor : PlayerDFSArmor)
{
	uiName = "";
};

datablock PlayerData(PlayerRecoverArmor : PlayerDFArmor)
{
	uiName = "Recover Player";
	showEnergyBar = 0;
	runEnergyDrain = 0;
};

function PlayerDFArmor::Damage(%data, %player, %a, %b, %amt, %dmgtype)
{
	Parent::damage(%data, %player, %a, %b, %amt, %dmgtype);

	if(!isObject(%player))
		return;

	if(isEventPending(%player.recoverSched))
		cancel(%player.recoverSched);

	%player.recoverSched = schedule(5000, 0, "RecoverHealth", %player);
}

function PlayerDFSArmor::Damage(%data, %player, %a, %b, %amt, %dmgtype)
{
	Parent::damage(%data, %player, %a, %b, %amt, %dmgtype);

	if(!isObject(%player))
		return;

	if(isEventPending(%player.recoverSched))
		cancel(%player.recoverSched);

	%player.recoverSched = schedule(5000, 0, "RecoverHealth", %player);
}

function PlayerRecoverArmor::Damage(%data, %player, %a, %b, %amt, %dmgtype)
{
	Parent::damage(%data, %player, %a, %b, %amt, %dmgtype);

	if(!isObject(%player))
		return;

	if(isEventPending(%player.recoverSched))
		cancel(%player.recoverSched);

	%player.recoverSched = schedule(5000, 0, "RecoverHealth", %player);
}

package Sprinting
{
	function Armor::onTrigger(%data,%player,%slot,%io)
	{
		%client = %player.client;
		if(%slot == 4)
		{
			if(!%player.checking)
				%player.staminaSched = schedule(100, 0, "StaminaCheck", %player);
			if(%io && %data.getName() $= "PlayerDFArmor")
				%player.changeDatablock(PlayerDFSArmor);
			else if(!%io && %data.getName() $= "PlayerDFSArmor")
				%player.changeDatablock(PlayerDFArmor);

			if(%io && %data.getName() $= "PlayerSprintArmor")
				%player.changeDatablock(PlayerSprintingArmor);
			else if(!%io && %data.getName() $= "PlayerSprintingArmor")
				%player.changeDatablock(PlayerSprintArmor);
		}
		Parent::onTrigger(%data,%player,%slot,%io);

		if(%slot == 2)
		{
			if(%io && %data.getName() $= "PlayerDFSArmor")
			{
				if(%player.getEnergyLevel() < 25)
				{
					%player.changeDatablock(PlayerDFArmor);
					serverplay3d(jumpsound,%player.getHackPosition());
				}
			}

			if(%io && %data.getName() $= "PlayerSprintingArmor")
			{
				if(%player.getEnergyLevel() < 25)
				{
					%player.changeDatablock(PlayerSprintArmor);
					serverplay3d(jumpsound,%player.getHackPosition());
				}
			}
		}
	}
};
activatePackage(Sprinting);